def notifyLINE(status) {
    def token = "PkKKa1UYK5GfdYCikW344RInuNKO4AV2MFDQvZJ3WUm"
    def jobName = env.JOB_NAME
    def buildNo = env.BUILD_NUMBER
      
    def url = 'https://notify-api.line.me/api/notify'
    def message = "${jobName} Build #${buildNo} ${status} \r\n"
    sh "curl ${url} -H 'Authorization: Bearer ${token}' -F 'message=${message}'"
}

pipeline {
    agent { label 'build' }
    environment {
        APP_NAME = "test app name"
        IMAGE = "registry.gitlab.com/sommai.k/simple-express"
    }

    stages {
        stage("Build Image") {
            steps {
                sh "echo ${env.APP_NAME}"
                sh "docker version"
                sh "docker build -t ${env.IMAGE} ."
                sh "docker tag ${env.IMAGE} ${env.IMAGE}:${env.BUILD_NUMBER}"
            }
        }

        stage("Deliver") {
            steps {
                withCredentials([usernamePassword(
                    credentialsId: 'gitlab.com',
                    passwordVariable: 'gitlabPassword',
                    usernameVariable: 'gitlabUser'
                )])
                {
                    sh "docker login -u ${env.gitlabUser} -p ${env.gitlabPassword} registry.gitlab.com"
                    sh "docker push ${env.IMAGE}:${env.BUILD_NUMBER}"
                    sh "docker push ${env.IMAGE}"
                    sh "docker rmi ${env.IMAGE}:${env.BUILD_NUMBER}"
                    sh "docker rmi ${env.IMAGE}"
                }
            }
        }

        stage("Deploy") {
            agent { label 'k8s' }
            steps {
                sh "kubectl apply -f deploy/simple-express.yml"
            }
        }
    }

    post{
        success{
            notifyLINE("succeed")
        }
        failure{
            notifyLINE("failed")
        }
    }

}